/*
   Test the turnpar, turnpro and turnrates routines.
*/
 
#include "SpiceUsr.h"
#include "SpiceZmc.h"
#include "SpiceZfc.h"

#define ROOM 1000

int main ()
{

   #define ROOM 1000
 
   SpiceBoolean found;
 
   SpiceDouble  angacc    [3];
   SpiceDouble  angacc2   [ROOM][3];
   SpiceDouble  angvel    [ROOM][3];
   SpiceDouble  alpha;
   SpiceDouble  omega     [3];
   SpiceDouble  t;
   SpiceDouble  ta        [ROOM];
   SpiceDouble  tb;
   SpiceDouble  tc;
   SpiceDouble  tv        [ROOM];
   SpiceDouble  trnrot    [ROOM][3][3];
   SpiceDouble  trntim    [ROOM];
   SpiceDouble  r1        [3];
   SpiceDouble  r2        [3];

   SpiceInt     i;
   SpiceInt     ier;
   SpiceInt     j;
   SpiceInt     k;
   SpiceInt     na;
   SpiceInt     nb;
   SpiceInt     nc;
   SpiceInt     nv;
   SpiceInt     nout;
   SpiceInt     opt;

/*
   Get program inputs.
*/

   printf( "Enter option code: " );
   scanf( "%d", &opt );
   printf( "option code = %d\n\n", opt );

   printf( "Enter first vector: " );
   scanf( "%lf %lf %lf", &r1[0], &r1[1], &r1[2] );
   printf( "first vector = %f %f %f\n\n", r1[0], r1[1], r1[2] );

   printf( "Enter  second vector: " );
   scanf( "%lf %lf %lf", &r2[0], &r2[1], &r2[2] );
   printf( "second vector = %f %f %f\n\n", r2[0], r2[1], r2[2] );

   printf( "Enter turn duration: ");
   scanf( "%lf", &t );
   printf( "turn duration = %f\n\n", t );


   if ( opt == 1 ) { 
      
      printf( "Enter boost duration (seconds):" );
      scanf( "%lf", &tb );
      printf( "boost duration = %f\n\n", tb );
 
   } else { 

      printf( "Enter boost angular acceleration (deg/sec^2):" );
      scanf( "%lf", &alpha );
      printf( "boost angular acceleration duration = %f\n\n", alpha );
   } 

/*
   Test subroutines
*/

   printf( "before turnpar\n");

   turnpar ( opt, r1, r2, t, 
             &alpha, &tb, 
             &tc, omega, angacc, &found, &ier );

   printf( "after turnpar\n");

   if ( found != SPICETRUE ) { 

      printf ( "no turn solution, ier = %d \n", ier );

   } else { 

      printf( "\n" ); 
      printf( "option = %d \n", opt );
      printf( "start vector = %f %f %f \n", r1[0], r1[1], r1[2]);
      printf( "end vector   = %f %f %f \n", r2[0], r2[1], r2[2]);
      printf( "angular acceleration = %f deg/sec^2\n", alpha*dpr_c() );
      printf( "angular acceleration = %f rad/sec^2\n", alpha);
      printf( "total turn duration = %f seconds\n", t );
      printf( "spinup duration = %f seconds\n", tb );
      printf( "coast duration = %f seconds\n", tc );
      printf( "angular velocity components = \n");
      for( i=0; i<3; i++ ) { 
         printf( "%f deg/sec\n", omega[i]*dpr_c() );
      } 
      for( i=0; i<3; i++ ) { 
         printf( "%f rad/sec\n", omega[i] );
      } 
      printf( "angular acceleration components = \n");
      for( i=0; i<3; i++ ) { 
         printf( "%f deg/sec^2\n", angacc[i]*dpr_c() );
      } 
      for( i=0; i<3; i++ ) { 
         printf( "%f rad/sec^2\n", angacc[i] );
      } 
    }

/*
   Test turnpro
*/

   printf( "Enter number of points in boost phase:");
   scanf( "%d", &nb );
   printf( "number of boost phase points = %d \n", nb );

   printf( "Enter number of points in coast phase:");
   scanf( "%d", &nc );
   printf( "number of coast phase points = %d \n", nc );

   turnpro ( t, tb, tc, angacc, nb, nc, ROOM,        
             &nout, trntim, trnrot );

   printf( "\n" );
   printf( "nb = %d\n", nb );
   printf( "nc = %d\n", nc );
   printf( "nout = %d\n\n", nout );

   printf( "orientation times and rates = \n" );

   for( i=0; i<nout; i++ ) { 
      printf( "\n" );
      printf( "%lf \n", trntim[i] );
      for( j=0; j<3; j++ ) {
         printf( "%f %f %f \n", trnrot[i][j][0], 
                                trnrot[i][j][1],  
                                trnrot[i][j][2] ); 
      } 
   }

/*
   Recover angular velocities and accelerations. 
*/

   turnrates ( ROOM, nout, trntim, trnrot, 
               &nv, tv,  angvel,  
               &na, ta,  angacc2 );

   

   printf( "\n" );
   printf( "nout = %d \n", nout );
   printf( "nv   = %d \n", nv );
   printf( "na   = %d \n", na );
   printf( "angular velocity vectors = \n" );

   for ( i=0; i<nv; i++ ) { 
      printf( "%f - %f %f %f \n", tv[i], angvel[i][0], 
                                         angvel[i][1], 
                                         angvel[i][2]);
   }

   printf( "\n" );
   printf( "angular acceleration vectors = \n" );

   for ( i=0; i<na; i++ ) { 
      printf( "%f - %f %f %f \n", ta[i], angacc2[i][0], 
                                         angacc2[i][1], 
                                         angacc2[i][2]);
   }

   exit(0);

}
  



